> ## Documentation Index
> Fetch the complete documentation index at: https://conductorone-docs-c1-ai-rename-product.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Bindings

> CreateBindings assigns up to 100 enabled, visible tools to an Assigned-tools Virtual MCP Server.
 Existing assignments are unchanged and previously deleted assignments are restored.



## OpenAPI

````yaml https://spec.speakeasy.com/conductor-one/conductorone/my-source-with-code-samples post /api/v1/virtual_mcp_servers/{virtual_mcp_server_id}/tool_bindings
openapi: 3.1.0
info:
  description: The C1 API is a HTTP API for managing C1 resources.
  title: C1 API
  version: 0.1.0-alpha
servers:
  - description: The C1 API server for the current tenant.
    url: https://{tenantDomain}.conductor.one
    variables:
      tenantDomain:
        default: example
        description: The domain of the tenant to use for this request.
security:
  - bearerAuth: []
    oauth: []
paths:
  /api/v1/virtual_mcp_servers/{virtual_mcp_server_id}/tool_bindings:
    post:
      tags:
        - Virtual MCP Servers
      summary: Create Bindings
      description: >-
        CreateBindings assigns up to 100 enabled, visible tools to an
        Assigned-tools Virtual MCP Server.
         Existing assignments are unchanged and previously deleted assignments are restored.
      operationId: c1.api.ai_governance.v1.VirtualMCPToolBindingService.CreateBindings
      parameters:
        - in: path
          name: virtual_mcp_server_id
          required: true
          schema:
            description: Immutable identifier of the Virtual MCP Server.
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/c1.api.ai_governance.v1.VirtualMCPToolBindingServiceCreateBindingsRequestInput
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/c1.api.ai_governance.v1.VirtualMCPToolBindingServiceCreateBindingsResponse
          description: >-
            VirtualMCPToolBindingServiceCreateBindingsResponse contains the
            resulting assignments.
components:
  schemas:
    c1.api.ai_governance.v1.VirtualMCPToolBindingServiceCreateBindingsRequestInput:
      description: >-
        VirtualMCPToolBindingServiceCreateBindingsRequest assigns individual
        tools to one Virtual MCP Server.
      properties:
        mcpTools:
          description: >-
            Complete MCP tool references to assign. Duplicate tuples are
            ignored.
          items:
            $ref: '#/components/schemas/c1.api.ai_governance.v1.MCPToolRef'
          type:
            - array
            - 'null'
      title: Virtual Mcp Tool Binding Service Create Bindings Request
      type: object
      x-speakeasy-name-override: VirtualMCPToolBindingServiceCreateBindingsRequest
    c1.api.ai_governance.v1.VirtualMCPToolBindingServiceCreateBindingsResponse:
      description: >-
        VirtualMCPToolBindingServiceCreateBindingsResponse contains the
        resulting assignments.
      properties:
        bindings:
          description: Created, existing, or restored individual tool assignments.
          items:
            $ref: '#/components/schemas/c1.api.ai_governance.v1.VirtualMCPToolBinding'
          type:
            - array
            - 'null'
      title: Virtual Mcp Tool Binding Service Create Bindings Response
      type: object
      x-speakeasy-name-override: VirtualMCPToolBindingServiceCreateBindingsResponse
    c1.api.ai_governance.v1.MCPToolRef:
      description: MCPToolRef is a reference to a specific MCP tool.
      properties:
        appId:
          description: The application the tool belongs to.
          type: string
        connectorId:
          description: The connector the tool was discovered through.
          type: string
        id:
          description: Unique identifier for the MCP tool.
          type: string
      title: Mcp Tool Ref
      type: object
      x-speakeasy-name-override: MCPToolRef
    c1.api.ai_governance.v1.VirtualMCPToolBinding:
      description: >-
        VirtualMCPToolBinding represents one individual tool assigned to a
        Virtual MCP Server.
      properties:
        createdAt:
          format: date-time
          type:
            - string
            - 'null'
        mcpTool:
          oneOf:
            - $ref: '#/components/schemas/c1.api.ai_governance.v1.MCPToolRef'
            - type: 'null'
        updatedAt:
          format: date-time
          type:
            - string
            - 'null'
        virtualMcpServerId:
          description: Immutable identifier of the Virtual MCP Server.
          type: string
      title: Virtual Mcp Tool Binding
      type: object
      x-speakeasy-name-override: VirtualMCPToolBinding
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http
    oauth:
      description: >-
        This API uses OAuth2 with the Client Credential flow.

        Client Credentials must be sent in the BODY, not the headers.

        For an example of how to implement this, refer to the
        [c1TokenSource.Token()](https://github.com/ConductorOne/conductorone-sdk-go/blob/3375fe7c0126d17e7ec4e711693dee7b791023aa/token_source.go#L101-L187)
        function.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /auth/v1/token
      type: oauth2

````